package futils;
import java.util.*;
import java.awt.*;
import java.io.*;

public final class Futil {
    /**
     * Don't let anyone instantiate this class.
     */
    private Futil() {}


   	
   public static  String getReadFileName() {
   			Frame frm = new Frame();
   			frm.setSize(100,100);
   	     	FileDialog dialog = new FileDialog(frm, "select file");
      		dialog.show();
      		String file_name = dialog.getFile();
      		String path_name = dialog.getDirectory();
      		String file_string = path_name + file_name;
      		System.out.println("Opening file: "+file_string);
      		dialog.dispose();
      		return file_string;
   }
   
   

  public static  FileOutputStream getWriteFileOutputStream() {
   try {
   	return 
   			new FileOutputStream(getWriteFileName());
   			}
   	catch (Exception e) {
   		System.out.println("Er: FileOutputStream in futils.java");}
   	return null;
   }
   
 public   static  String getWriteFileName() {
   	     	FileDialog dialog = new FileDialog(new Frame(), "Enter file name",FileDialog.SAVE);
      		dialog.show();
      		String fs = dialog.getDirectory() + dialog.getFile();
      		System.out.println("Opening file: "+fs);
      		dialog.dispose();
      		return FilterFileNameBug(fs);
   }
 public   static  String getWriteDirectoryName() {
   	     	FileDialog dialog = new FileDialog(new Frame(), "Enter file name",FileDialog.SAVE);
      		dialog.show();
      		String fs = dialog.getDirectory();
      		System.out.println("Opening file: "+fs);
      		dialog.dispose();
      		return FilterFileNameBug(fs);
   }
   
// Some versions of windows will
// create a .* suffix on a file name
// The following code will strip it:
public static String FilterFileNameBug(String fname) {
               if (fname.endsWith(".*.*")) {
		  fname=fname.substring(0, fname.length() - 4);
		}
    return fname;
}

 public   static  File getWriteFile() {
      		return new File(getWriteFileName());
   } 

 public   static  File getDirFile() {
      		return new File(Ls.getDirName());
    }
  
 public  static  File getReadFile() {
      		return new File(getReadFileName());
      	}
      
public static FileInputStream getFileInputStream() {
    	return  getFileInputStream(getReadFileName());
    }
 
public static FileInputStream getFileInputStream(String name) {
 FileInputStream fis = null;
    try 
    	{fis =  new FileInputStream(name);}
    catch (IOException e) 
    	{System.out.println("futil:Could not open file");}
    	return fis;
    }
public static FileInputStream getFileInputStream(File file) {
 FileInputStream fis = null;
    try 
    	{fis =  new FileInputStream(file);}
    catch (IOException e) 
    	{System.out.println("futil:Could not open file");}
    	return fis;
    }

public static FileWriter getFileWriter() {
    FileWriter fw = null;
    try {fw =  
    		new FileWriter(getWriteFileName());
    	}
    catch (IOException e) {
    		System.out.println("futil:Could not create file");
    	}
    	return fw;
    }
    
// Open the file, return -1 if file cannot be opened
// otherwise return the size in bytes
public static int available(File file) {
 FileInputStream fis = null;
 int sizeInBytes = -1;
    try {
    	fis =  new FileInputStream(file);
        sizeInBytes = fis.available();
    	fis.close();
    }
    catch (IOException e) 
    	{System.out.println("Futil:Could not open file");}
    	return sizeInBytes;
}
   
 public static void close(FileWriter fw) {
   try {fw.close();} // end try
    catch (IOException exe) 
    	{System.out.println("futil: could not close output stream");}      		   		
   }
  
  public static void closeInputStream(InputStream is) {
   try {is.close();} // end try
    catch (IOException exe) 
    	{System.out.println("futil: could not close input stream");}      		   		
   }

		
       
  public    static  void lsWordPrintMerge() {
      		String wild = "pict";

           	String[] files = Ls.getWildNames(wild);
           	
      		System.out.println(files.length + " file(s):");
      		
      		for (int i=0; i < files.length; i++)
      			System.out.println("\t" + files[i]);

      }
      
 
      
    
  static public void filterHtmls() {
          	String[] files = Ls.getWildNames(".html");
          	File input_dir = getDirFile();
      		System.out.println(files.length + " file(s) to process");
      		
      		File output_dir = new File(input_dir.getParent(),"out");
      		if (output_dir.exists()) 
      				{System.out.println("Output dir exists:"+ output_dir);}
      		else {output_dir.mkdir();}
 
      		for (int i=0; i < files.length; i++) {   			 	
      			 		writeFilteredHrefFile(input_dir+files[i],output_dir+"/"+files[i]);
      			 	} 
    }
    
public static  void writeFilteredHrefFile(String inputName, String outputName) { 
    System.out.println("Filtering:\t" + inputName +"\t>\t"+outputName);
    try {
    	FileInputStream is = new FileInputStream(inputName);
		InputStreamReader isr = new InputStreamReader(is);
		BufferedReader br = new BufferedReader(isr);
        StreamTokenizer tokens = new StreamTokenizer(br);
        FileWriter os = new FileWriter(outputName);
        PrintWriter output = new PrintWriter(os);
        int i;
        int next = 0;
        tokens.resetSyntax();
        tokens.wordChars(0,255);
        tokens.quoteChar('"');
        while ((next = tokens.nextToken()) != tokens.TT_EOF) {
           	switch (next) {
           		case '"':
           		 	output.print('"');
           		 	for (i=0;i<tokens.sval.length();i++) 
 				  if (tokens.sval.charAt(i) == ' ') 
 					output.print("%20");
 				  else
 					output.print(tokens.sval.charAt(i));
           		 	output.print('"');
           		 	break;
           		case tokens.TT_WORD: 
           		 	output.print(tokens.sval+" ");
           		 	break;
           		case tokens.TT_NUMBER:
           		 	output.print(tokens.nval+" "); 	
           		 	break;
           	    case tokens.TT_EOL:
           		 	output.println();
           		 	break;
           		} // end switch
           	} // end while
           is.close();
           os.close();
    } // end try
    catch (Exception exe) 
    	{System.out.println("writeFilteredHrefFile:er!");}
  } 
    
   public static void main(String[] args) {
    String name = getReadFileName( ) ;
    System.out.println("HEllo world, I got:"+name);
		try {
			System.in.read(); // prevent console window from going away
		} catch (java.io.IOException e) {}

   } 
    public static  void writeFilteredJavaFile( ) { 
    try {
    	FileInputStream is = getFileInputStream();
		InputStreamReader isr = new InputStreamReader(is);
		BufferedReader br = new BufferedReader(isr);
        StreamTokenizer tokens = new StreamTokenizer(br);
        PrintStream output = System.out;
        int i;
        int next = 0;
        tokens.resetSyntax();
        tokens.wordChars(0,255);
        tokens.quoteChar(';');
        while ((next = tokens.nextToken()) != tokens.TT_EOF) {
           	switch (next) {
           		case ';':
           		 	
           		 	output.print("got a line:"+tokens.lineno());
           		 	break;
           		case tokens.TT_WORD: 
           		 	output.print(tokens.sval+" ");
           		 	break;
           		case tokens.TT_NUMBER:
           		 	output.print(tokens.nval+" "); 	
           		 	break;
           	    case tokens.TT_EOL:
           		 	output.println();
           		 	break;
           		} // end switch
           	} // end while
           is.close();
    } // end try
    catch (Exception exe) 
    	{System.out.println("writeFilteredHrefFile:er!");}
  } 

  public  static  void list_filtered_href_file(String file) {
    	System.out.println("processing:\t" + file);
    	try {
    	FileInputStream is = new 
           		 	FileInputStream(file);
        InputStreamReader isr = new InputStreamReader(is);
		BufferedReader br = new BufferedReader(isr);
           		 StreamTokenizer tokens = new StreamTokenizer(br);
           		 int next = 0;
           		 tokens.resetSyntax();
           		 tokens.wordChars(0,255);
           		 tokens.quoteChar('"');
           		 while ((next = tokens.nextToken()) != tokens.TT_EOF) 
           		 {
           		 	switch (next) {
           		 		case '"':
           		 			System.out.print('"');
           		 			StringTokenizer st = 
           		 				new StringTokenizer(tokens.sval," ");
           		 			while (st.hasMoreTokens()) {
           		 				System.out.print(st.nextToken());
           		 				if (st.countTokens() > 1) 
           		 					{System.out.print("%20");}
           		 			}
           		 			System.out.print('"');
           		 			break;
           		 		case tokens.TT_WORD: 
           		 			System.out.print(tokens.sval+" ");
           		 			break;
           		 		case tokens.TT_NUMBER:
           		 			System.out.print(tokens.nval+" "); 	
           		 			break;
           		 		case tokens.TT_EOL:
           		 			System.out.println();
           		 			break;
           		 	}
           		 }
           		 System.out.println();
      closeInputStream(is);
    	}
    	catch (Exception exe) 
    		{System.out.println("list_filtered_href_file:er!");}
    }
	
public static  void filterFileHrefs() {
FileInputStream is = getFileInputStream();
InputStreamReader isr = new InputStreamReader(is);
BufferedReader br = new BufferedReader(isr);
  StreamTokenizer tokens = new StreamTokenizer(br);
  int next = 0;
  tokens.resetSyntax();
  tokens.wordChars(0,255);
  tokens.quoteChar('"');
  
  try { while ((next = tokens.nextToken()) 
  	!= tokens.TT_EOF) {
         switch (next) {
           	case '"':
           		 System.out.print('"');
           		 StringTokenizer st = 
           		 	new StringTokenizer(tokens.sval," ");
           		 while (st.hasMoreTokens()) {
           		 	System.out.print(st.nextToken());
           		 	if (st.countTokens() > 1) 
           		 	{System.out.print("%20");}
           		 }
           		 System.out.print('"');
           		 break;
           	case tokens.TT_WORD: 
           		 System.out.print(tokens.sval+" ");
           		 break;
           	case tokens.TT_NUMBER:
           		System.out.print(tokens.nval+" "); 	
           		break;
           	case tokens.TT_EOL:
           		 System.out.println();
           		break;
           	} // switch
     }} // try while
     catch (IOException e) {
     	System.out.println("Futil:ER! filterFileHrefs");
     }
      System.out.println();
      closeInputStream(is);
 }
   

   public  static   void processJava() {
   	FileInputStream fis = getFileInputStream();
        String line;
        FileInputStream is = getFileInputStream();
		InputStreamReader isr = new InputStreamReader(is);
		BufferedReader br = new BufferedReader(isr);
        System.out.println("<HTML><BODY><PRE>");
        try { while ((line = br.readLine()) != null) 
           	System.out.println(line);
           	}
        catch (IOException e) {
        	System.out.println("Futil: ER! in processJava");
        }
        System.out.println("</PRE></BODY></HTML>");
        closeInputStream(is);           		   		
   }
   
public void lowerFileNames( File thePath ){
	String[] fileNames = thePath.list();
        String pathstr = thePath.getPath();
        for( int i=0; 
        	fileNames != null && 
        	i< fileNames.length; i++ ) {
            String aFileName = fileNames[ i ];
            String newFileName = aFileName.toLowerCase();
            File theFile = new File( pathstr, aFileName );
            if( theFile.isFile() ){
            //rename theFile to lower case
                System.out.print( i+":" + aFileName );
                theFile.renameTo( new File( pathstr, newFileName ) );
                System.out.println( "\t==>\t"+newFileName );
            }else{
            //case theFile is Dir, in the Dir, repeat same procedure
                System.out.println( "Dir:"+aFileName );
                lowerFileNames( new File( pathstr+aFileName ));
            }
        }
        return;
    }//lowerFileNames
    
 
   public    static   void makeTocHtml() {
   	File dir = getDirFile();
   	String[] files = dir.list(new FileFilter());
      	System.out.println(files.length + " file(s):");
      	FileWriter fw = getFileWriter();
        PrintWriter ps = new PrintWriter(fw);
        ps.println("<HTML>");
        ps.println("<BODY>"); 
        ps.println("<ul>");
      	for (int i=0; i < files.length; i++)
      		ps.println("<LI><a href = \"" + files[i]+"\">"+
      			files[i]+"</a><P>");
      	ps.println("</ul>");
      	ps.println("</BODY>");
      	ps.println("</HTML>");
      	close(fw);		   		
   }
   
   
 public static  void readDataFile(String file,double data[]) {
    System.out.println("processing:\t" + file);
    FileInputStream is =  
           		 	getFileInputStream(file);
	InputStreamReader isr = new InputStreamReader(is);
	BufferedReader br = new BufferedReader(isr);
    StreamTokenizer tokens = new StreamTokenizer(br);
    int next = 0;
    int num = 0;
    try {
          while ((next = tokens.nextToken()) != tokens.TT_EOF) {
           	switch (next) {
           		 case tokens.TT_WORD: 
           		 	break;
           		 case tokens.TT_NUMBER:
           		 	data[num] = (double) tokens.nval;
           		 	System.out.println(num+": "+ data[num]);
           		 	num = num + 1; 	
           		 	break;
           		 case tokens.TT_EOL:
           		 	break;
           	}
           }
           		 
    	}
    	catch (Exception exe) 
    		{System.out.println("listFilteredHrefFile:er!");}
    	closeInputStream(is);
    }

}